set verify off
set heading off
set feedback off
set timing off

accept   vo prompt 'Informe o Owner: '
accept   dir prompt 'Diretorio de spool: '


column global_name new_value instancia noprint
select replace(global_name, '.WORLD', '') global_name from global_name;


spool "&dir\&Vo._&instancia._1.drop_obj_schema.sql"
prompt spool "&dir\&Vo._&instancia._1.drop_obj_schema.log"


prompt
prompt set echo on
prompt



select   'ALTER TABLE '||OWNER||'."'||TABLE_NAME||'" DROP CONSTRAINT "'||CONSTRAINT_NAME||'";'
from     dba_constraints
where    owner = upper('&Vo')
and      constraint_type = 'R'
order by table_name, constraint_name
/


select   'DROP SEQUENCE '||SEQUENCE_OWNER||'."'||SEQUENCE_NAME||'";'
from     dba_sequences
where    sequence_owner = upper('&Vo')
order by SEQUENCE_NAME
/


select   'DROP '||TYPE||' '||OWNER||'."'||NAME||'";'
from     dba_source
where    owner = upper('&Vo')
group by owner, type, name
order by name
/


select   'DROP VIEW '||OWNER||'."'|| VIEW_NAME||'";'
from     dba_views
where    owner = upper('&Vo')
order by VIEW_NAME
/


select   'DROP TABLE '||OWNER||'."'||TABLE_NAME||'" PURGE;'
from     dba_tables
where    owner = upper('&Vo')
order by TABLE_NAME
/


select   'DROP TYPE '||OWNER||'."'||TYPE_NAME||'";'
from     dba_types
where    owner = upper('&Vo')
order by TYPE_NAME
/



select   'DROP MATERIALIZED VIEW '||OWNER||'."'||MVIEW_NAME||'";'
from     dba_mviews
where    owner = upper('&Vo')
order by MVIEW_NAME
/




SELECT 'PURGE TABLE ' || OWNER || '."' || ORIGINAL_NAME  || '";'
FROM dba_recyclebin 
WHERE owner = upper('&Vo')
and type = 'TABLE'
order by ORIGINAL_NAME
/


prompt
prompt set echo off
prompt


prompt
prompt spool off
spool off







spool "&dir\&Vo._&instancia._3.create_syn.sql"
prompt spool "&dir\&Vo._&instancia._3.create_syn.log"



prompt
prompt set echo on
prompt



select 'create public synonym ' || synonym_name || ' for ' || table_owner || '.' || table_name || ';'
from dba_synonyms
where table_owner = upper('&Vo')
and owner = 'PUBLIC'
and db_link is null
order by synonym_name
/


prompt
prompt
prompt



select 'create synonym ' || owner || '.' || synonym_name || ' for ' || table_owner || '.' || table_name || ';'
from dba_synonyms
where owner = upper('&Vo')
and db_link is null
order by owner, synonym_name
/


prompt
prompt



select 'create public synonym ' || synonym_name || ' for ' || table_owner || '.' || table_name || '@' || db_link || ';'
from dba_synonyms
where table_owner = upper('&Vo')
and owner = 'PUBLIC'
and db_link is not null
order by synonym_name
/


prompt
prompt
prompt



select 'create synonym ' || owner || '.' || synonym_name || ' for ' || table_owner || '.' || table_name || '@' || db_link || ';'
from dba_synonyms
where owner = upper('&Vo')
and db_link is not null
/



prompt set echo off
prompt



prompt
prompt spool off
spool off






spool "&dir\&Vo._&instancia._2.dump_ed_grants.sql"
prompt spool "&dir\&Vo._&instancia._2.dump_ed_grants.log"

prompt
prompt set echo on
prompt


select (case 
	when grantable = 'NO' then
		'GRANT '||privilege||' on '||owner||'."'||table_name||'" to "'||grantee||'";' 
	else
		'GRANT '||privilege||' on '||owner||'."'||table_name||'" to "'||grantee||'" with grant option;' end ) commamd 
FROM dba_tab_privs 
WHERE (owner = upper('&Vo'))
ORDER BY grantee
/



prompt
prompt set echo off
prompt


prompt
prompt spool off
spool off




undef vo
undef dir
undef instancia

set verify on
set heading on
set feedback on
